/*! \file SingVertexElementResult.h 
 *  \brief: header file for triavertexresult object
 */


#ifndef _SINGVERTEXELEMENTRESULT_H_
#define _SINGVERTEXELEMENTRESULT_H_

/*Headers:*/
/*{{{1*/
#include "../Inputs/Input.h"
#include "../../include/include.h"
/*}}}*/

class SingVertexElementResult: public SingVertexInput,public ElementResult{

	private: 
		int    step;
		double time;

	public:

		/*constructors, destructors: {{{1*/
		SingVertexElementResult();
		SingVertexElementResult(int enum_type,double value,int step,double time);
		~SingVertexElementResult();
		/*}}}*/
		/*object management: {{{1*/
		void  DeepEcho();
		void  Echo();
		int   Id(); 
		void  Marshall(char** pmarshalled_dataset);
		int   MarshallSize();
		void  Demarshall(char** pmarshalled_dataset);
		int   Enum();
		int   MyRank();
		Object* copy();
		int   EnumType();
		
		void    InputUpdateFromVector(double* vector, int name, int type){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromVector(int* vector, int name, int type){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromVector(bool* vector, int name, int type){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromConstant(double constant, int name){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromConstant(int constant, int name){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromConstant(bool constant, int name){ISSMERROR("Not implemented yet!");}
		void    InputUpdateFromSolution(double* solution, int analysis_type, int sub_analysis_type){ISSMERROR("Not implemented yet!");}

		/*}}}*/
		/*result virtual functions: {{{1*/
		ElementResult* SpawnSingElementResult(int  index){ISSMERROR("Not implemented yet!");}
		ElementResult* SpawnBeamElementResult(int* indices){ISSMERROR("Not implemented yet!");}
		ElementResult* SpawnTriaElementResult(int* indices){ISSMERROR("Not implemented yet!");}
		void    ProcessUnits(Parameters* parameters);
		int     NumberOfNodalValues(void);
		void    PatchFill(int row, Patch* patch);
		/*}}}*/

};
#endif  /* _SINGVERTEXELEMENTRESULT_H */
